﻿/*
*   imageButton
*   author: ronglin
*   create date: 2010.06.22
*/

/*
* config parameters:
* renderTo, imageUrl, highlightCss, disabledCss
* onClick
*/

(function (ctx, $) {

    var imageButton = function (config) {
        $.extend(this, config);
        this.initialize();
    };

    imageButton.prototype = {

        el: null, renderTo: null, title: null,

        imageUrl: '', highlightCss: null, disabledCss: null,

        inited: false, disabled: false,

        constructor: imageButton,

        initialize: function () {
            var html = this.buildHtml();
            this.el = $(html).appendTo(this.renderTo);
            // events
            this.bindEvents();
            // disabled css
            this.isEnable(!this.disabled);
            // title
            if (this.title) { this.setTitle(this.title); }
            // set status
            this.inited = true;
        },

        bindEvents: function () {
            var self = this;
            this.el.hover(function () {
                if (self.disabled == false && ctx.dialoging != true)
                    $(this).addClass(self.highlightCss || 'kb-imageButton-highlight');
            }, function () {
                //if (self.disabled == false)
                $(this).removeClass(self.highlightCss || 'kb-imageButton-highlight');
            }).click(function (ev) {
                if (self.disabled == false && ctx.dialoging != true)
                    self.onClick(ev);
            });
        },

        buildHtml: function () {
            var src = (ctx.rootPath || '') + this.imageUrl;
            return '<img class="kb-imageButton" border="0" src="' + src + '" />';
        },

        setSrc: function (src) {
            src = (ctx.rootPath || '') + src;
            this.el.attr('src', src);
        },

        setTitle: function (title) {
            var t = title || this.title;
            this.el.attr('alt', t);
            this.el.attr('title', t);
        },

        // public
        remove: function () {
            this.el.remove();
        },

        // public
        isEnable: function (enable) {
            this.disabled = (enable === false);
            if (this.disabled) {
                this.el.addClass(this.disabledCss || 'kb-imageButton-disabled');
            } else {
                this.el.removeClass(this.disabledCss || 'kb-imageButton-disabled');
            }
        },

        // public config
        onClick: function (ev) {
        }
    };

    // register
    ctx.imageButton = imageButton;

})(yardi, jQuery);
