﻿/*
*   combo
*   author: ronglin
*   create date: 2010.05.28
*/

(function (ctx, $) {

    var combo = function (config) {
        $.extend(this, config);
        this.initialize();
    };

    combo.prototype = {

        width: 160, height: 18, title: null, disabled: false,

        onClick: null, renderTo: 'body',

        el: null, input: null,

        constructor: combo,

        initialize: function () {
            // el
            this.el = $(this.getHtml()).appendTo(this.renderTo);
            if (this.title) { this.el.attr('title', this.title); }
            // input
            this.input = this.el.children('.kb-inner'); //this.input = $('input', this.el);
            this.input.width(this.width - 11); // 11 is the background image width
            this.input.height(this.height).css('line-height', this.height + 'px');
            // event
            this.el.click(function () {
                if (self.disabled == false && ctx.dialoging != true) {
                    self.onClick && self.onClick.call(self, self.el);
                }
            });
            // highlight css
            var self = this;
            this.el.hover(function () {
                if (self.disabled == false && ctx.dialoging != true)
                    $(this).addClass('kb-combo-hl');
            }, function () {
                //if (self.disabled == false)
                $(this).removeClass('kb-combo-hl');
            });
            // disabled css
            this.isEnable(!this.disabled);
        },

        getHtml: function () {
            var html = [];
            html.push('<var class="kb-combo">');
            html.push('<var class="kb-inner"></var>'); //html.push('<input type="text" readonly="readonly" />');
            html.push('</var>');
            return html.join('');
        },

        remove: function () {
            this.el.remove();
        },

        isEnable: function (enable) {
            this.disabled = (enable === false);
            //this.input.attr('disabled', this.disabled);
            if (this.disabled) {
                this.el.addClass('kb-combo-disabled');
            } else {
                this.el.removeClass('kb-combo-disabled');
            }
        },

        val: function () {
            return this.input.text.apply(this.input, arguments);
        },

        css: function () {
            return this.input.css.apply(this.input, arguments);
        }
    };

    // register
    ctx.combo = combo;

})(yardi, jQuery);
